-------------------------------------------------------------------------------------
-- | Namespace Definitions |---------------------------------------------------------
-------------------------------------------------------------------------------------

-- Retrieve the addon name and the namespace table.
local addon, npcg = ...

local functua = npcg.functua
local stringLib = npcg.functua.string
local util = npcg.functua.util

-------------------------------------------------------------------------------------
-- | Events |------------------------------------------------------------------------
-------------------------------------------------------------------------------------

function npcFrame_OnLoad(self)
	-- Set up the TabContextFrame
	self["Tabs"]["ContextFrame"] = CreateFrame("Frame", "TabContextFrame", self["Tabs"], "TabRightClickMenuTemplate")
	--self["Tabs"]["ContextFrame"]:SetScript("OnEnter", function() self.HelperMessageFrame:AddMessage("Press escape to close this list") end)
	--self["Tabs"]["ContextFrame"]["CloseTabButton"]:SetScript("OnEnter", function() SetHelperText("Close this tab") end)
	--self["Tabs"]["ContextFrame"][    "LoadButton"]:SetScript("OnEnter", function() self.HelperMessageFrame:AddMessage(   "Load an npc") end)
	--self["Tabs"]["ContextFrame"][    "SaveButton"]:SetScript("OnEnter", function() self.HelperMessageFrame:AddMessage("Save an npc to permament storage") end)
	
	self["Tabs"]["TabButtons"][1]:HookScript("OnClick", function(self, button, isDown)
		
		if button == "RightButton" and     isDown and not self:GetParent()["ContextFrame"]:IsVisible() then
			self:GetParent()["ContextFrame"]:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
			self:GetParent()["ContextFrame"]["GetTabIndex"] = function() return 1 end
			self:GetParent()["ContextFrame"]["CloseTabButton"]:SetScript("OnClick", function()
					self:GetParent()["RemoveTab"](1)
					self:GetParent()["ContextFrame"]:Hide()
				end)
			self:GetParent()["ContextFrame"]:Show()
		else
			self:GetParent()["ContextFrame"]:Hide()
		end
		
	end)
	
	
	self["Tabs"]["OnTabAdded"] = function(tabIndex)
		self["Tabs"]["TabButtons"][tabIndex]:HookScript("OnClick", function(self, button, isDown)
			
			
			if button == "RightButton" and     isDown and not self:GetParent()["ContextFrame"]:IsVisible() then
				self:GetParent()["ContextFrame"]:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
				self:GetParent()["ContextFrame"]["GetTabIndex"] = function() return tabIndex end
				self:GetParent()["ContextFrame"]["CloseTabButton"]:SetScript("OnClick", function()
					self:GetParent()["RemoveTab"](tabIndex)
					self:GetParent()["ContextFrame"]:Hide()
				end)
				
				self:GetParent()["ContextFrame"]:Show()
			else
				self:GetParent()["ContextFrame"]:Hide()
			end
		end)
		self["Tabs"]["TabButtons"][tabIndex]:SetScript("OnEnter", function(self)
			SetHelperInfo(
				npcg.functua.string.ucWords(
					npcg.functua.util.eitherOr(
						not npcg.functua.string.nilOrWhitespace(GetCharacterTemplateInTab(tabIndex).name),
						GetCharacterTemplateInTab(tabIndex).name, "Unnamed npc #" .. tabIndex)),
				self,
			npcg.functua.util.eitherOr(
				not npcg.functua.string.nilOrWhitespace(GetCharacterTemplateInTab(tabIndex).class) and not npcg.functua.string.nilOrWhitespace(GetCharacterTemplateInTab(tabIndex).race),
				npcg.functua.string.ucWords(GetCharacterTemplateInTab(tabIndex).race .. " " .. GetCharacterTemplateInTab(tabIndex).class),
				nil)
			)
		end)
	end

	self["Tabs"]["AddTabButton"]:HookScript("OnClick", function()
		self["Tabs"]["ContextFrame"]:Hide()
	end)

	self["Tabs"]["AddTabButton"]:HookScript("OnEnter", function(self)
		SetHelperText("Open a new tab", self)
	end)
	
	self["Tabs"]["TabButtons"][1]:SetScript("OnEnter", function(self) 
		SetHelperInfo(
			npcg.functua.string.ucWords(
				npcg.functua.util.eitherOr(
					not npcg.functua.string.nilOrWhitespace(GetCharacterTemplateInTab(1).name),
					GetCharacterTemplateInTab(1).name, "Unnamed npc #" .. 1)),
			self,
			npcg.functua.util.eitherOr(
				not npcg.functua.string.nilOrWhitespace(GetCharacterTemplateInTab(1).class) and not npcg.functua.string.nilOrWhitespace(GetCharacterTemplateInTab(1).race),
				npcg.functua.string.ucWords(GetCharacterTemplateInTab(1).race .. " " .. GetCharacterTemplateInTab(1).class),
				nil)
			)
	end)
	
	
	--self.HelperMessageFrame:SetFadeDuration(1)
	--self.HelperMessageFrame:SetTimeVisible(1)
	
	npcGenerator.OnLoad()
	self:RegisterForDrag("LeftButton")
end

-------------------------------------------------------------------------------------
-- | Tooltip Functions |-------------------------------------------------------------
-------------------------------------------------------------------------------------

function SetHelperText(text, item)
	--npcGenerator_NPC_Frame.HelperMessageFrame:AddMessage(text)
	
	if NPCG_Options.interface.enableTooltips == true then	
		if item ~= nil then
			GameTooltip:SetOwner(item, "ANCHOR_RIGHT")
			GameTooltip:SetText(text, 1, 1, 1)
			GameTooltip:FadeOut()
		end
	end
end

function SetHelperInfo(title, item, ...)
  --npcGenerator_NPC_Frame.HelperMessageFrame:AddMessage(title)
	if NPCG_Options.interface.enableTooltips == true then	
		if item ~= nil then
			GameTooltip:SetOwner(item, "ANCHOR_RIGHT")
			GameTooltip:SetText(title, 1, 1, 1)
			
			local arg = {...}
				for i,_ in pairs(arg) do 
					GameTooltip:AddLine(arg[i], 1.00,	0.82,	0.00, 1)
				end
				
			GameTooltip:Show()
			GameTooltip:FadeOut()
		end
	end
end

function SetHelperTextWarning(text)
  --npcGenerator_NPC_Frame.HelperMessageFrame:AddMessage(text)
end

function SetHelperTextError(text)
  --npcGenerator_NPC_Frame.HelperMessageFrame:AddMessage(text)
end

function SetHelperTextOption(text, item)
  --npcGenerator_NPC_Frame.HelperMessageFrame:AddMessage(text)
	if NPCG_Options.interface.enableTooltips == true then	
		if item ~= nil then
			GameTooltip:SetOwner(item, "ANCHOR_RIGHT")
			GameTooltip:SetText(text, 1.00,	0.82,	0.00, 1)
			GameTooltip:FadeOut()
		end
	end
end