-------------------------------------------------------------------------------------
-- | Namespace Definitions |---------------------------------------------------------
-------------------------------------------------------------------------------------

-- Retrieve the addon name and the namespace table.
local addon, npcg = ...

local functua = npcg.functua
local stringLib = npcg.functua.string
local util = npcg.functua.util

function npcGenerator_settings_Frame_OnLoad()
  local frame = npcGenerator_settings_Frame
  tinsert(UISpecialFrames, frame:GetName())
  
  
  -- Make sure no more than one setting screen is open at the same time. Might be used later.
  npcGenerator_NPC_Frame.ExpandRightButton:SetScript("OnClick", function()
    if frame:IsVisible() then
      frame:Hide()
    else
      if frame:GetParent().activeExpandedFrame then
        frame:GetParent().activeExpandedFrame:Hide()
      end
      frame:GetParent().activeExpandedFrame = frame
      frame:Show()
    end
  end)
  
  npcGenerator_NPC_Frame.ExpandRightButton:SetScript("OnEnter", function()
    SetHelperText("Customize the generator", npcGenerator_NPC_Frame.ExpandRightButton)
  end)
  
  --[[
  frame.Panel.ContextToggle:HookScript("PostClick", function(self, button, down)
    if self:GetChecked() then
      NPCG_Options.tribeSettings.factionMatchingMode = "Context-based"
    else
      NPCG_Options.factionSettings.context  -- This cannot be clicked when faction forcing is disabled, so no need to check.
    end
  end)
    
  frame.Panel.ForceFactionToggle:HookScript("PostClick", function(self, button, down)
    if self:GetChecked() and frame.Panel.ContextToggle:GetChecked() then
      NPCG_Options.tribeSettings.factionMatchingMode = "Context-based"
    elseif self:GetChecked() then -- Only faction matching, but no context matching.  
      NPCG_Options.tribeSettings.factionMatchingMode = "Faction-based"
    else
      NPCG_Options.tribeSettings.factionMatchingMode = "All"
    end
  end)]]
end

function npcGenerator_settings_Frame_EditBox_MockZone_OnShow(self)
	self:SetText(util.eitherOr(
		not stringLib.nilOrWhitespace(NPCG_Options.locationSettings.mockZone),
		NPCG_Options.locationSettings.mockZone,
		self.defaultText))
	self.Refresh()
end

function npcGenerator_settings_Frame_EditBox_MockSubZone_OnShow(self)
	self:SetText(util.eitherOr(
		not stringLib.nilOrWhitespace(NPCG_Options.locationSettings.mockSubZone),
		NPCG_Options.locationSettings.mockSubZone,
		self.defaultText))
	self.Refresh()
end